//***********************************************************
//*
//* File:           IFCModel.java
//* Author:         Srikant Krishna
//* Contact:        srikant@cs.columbia.edu
//* Update:         9.5.2002
//*
//* Description:    Model interface for all projects.
//*                 Rather than separate the model from
//*                 the view, the views are delegated
//*                 by the game models.
//*
//***********************************************************

package ui;

import java.io.Serializable;
import javax.swing.*;

public interface IFCModel extends Serializable {
    
    public JPanel           exportViewPanel()               throws Exception;
    public JPanel           exportControlPanel()            throws Exception;
    public IFCConfiguration exportConfiguration()           throws Exception;
    public JButton[]        exportTools()                   throws Exception;   
    public JMenu            exportMenu()                    throws Exception;
    public void             register(IFCUI __UI)            throws Exception;
    public String           name()                          throws Exception;
    public void             run(IFCTournament __tournament) throws Exception;
}
