package Rectangles;

import ui.*;
import java.util.*;
import java.io.*;
import java.awt.Color;

public class OldG4Strategy4 extends OldG4Strategy {

    Rectangles _rect;

    int[] direction; 
    int diag_rectsize = 4;
    int sqsize = 4;
    int[] counter;
    final char[] MOVE = {'S', 'E', 'N', 'W'};
    final char[] MOVE3 = {'W', 'N', 'E', 'S'};
    final char[] DIAGMOVE2 = {'N', 'E', 'S', 'E', 'N', 'W'};
    int[] numRects;
    int _MAX;
    boolean[] boundaryPlayerFlag;
    boolean[] clockwise;
    boolean clockwiseFlag = true;
    int size;
    boolean[] finishDiags;
    String[] botPlayers;
    Robot[] robots;
    int fillerThresh = 4;
    boolean[][] filled;
    int[][] colors;
    boolean[] fillerStatus;
    int[] fillerLength;
    int[] fillerWidth;
    int fillerVertexCounter = 0;
    int diagRightPlayerCount = 0;
    int diagLeftPlayerCount = 0;
    int diagStartPoint = 1;
    int fillerMaxCount = 5;
    int[] fillerCounter;
    static final String _DIAGONAL = new String("DiagonalPlayer");
    static final String _BOUNDARY = new String("BoundaryPlayer");
    static final String _FILLER = new String("FillerPlayer");
    static final String _CHASER = new String("Chaser");
    int numBoundaryPlayers;
    int numFillerPlayers;
    Vertex[] curFiller;
    Vertex[] prevVertex;
    int playerIndex;
    
    Random random = new Random();
    
    /************************************************
     * CONSTRUCTOR
     ************************************************/
    public OldG4Strategy4(Rectangles _rect, int index) throws Exception{
	this._rect = _rect;
	playerIndex = index;
        _MAX = _rect.numRobots();
	size = _rect.size();
	robots = new Robot[_MAX];
	initialize();
    }

    public void initialize() throws Exception{
	direction = new int[_MAX];
	botPlayers = new String[_MAX];
	counter = new int[_MAX];
	boundaryPlayerFlag = new boolean[_MAX];
	finishDiags = new boolean[_MAX];
	numRects = new int[_MAX];
	clockwise = new boolean[_MAX];
	curFiller = new Vertex[_MAX];
	prevVertex = new Vertex[_MAX];
	fillerCounter = new int[_MAX];
	fillerStatus = new boolean[_MAX];
	fillerLength = new int[_MAX];
	fillerWidth = new int[_MAX];
	numBoundaryPlayers = 1;
	numFillerPlayers = _MAX-numBoundaryPlayers;
	if(size < 4){
	    diag_rectsize = size;
	    sqsize = size;
	    fillerThresh = size;
	}else{
		double tmp = size/50.0;
		if(tmp < 1.0)
			tmp = 1.0;
		
		tmp*=4.0;

		diag_rectsize=(int)tmp;
	    sqsize = diag_rectsize;
	    fillerThresh = diag_rectsize;
	}

	for(int i=0; i<_MAX; i++){
	    botPlayers[i]= new String("");
	    counter[i] = 1;
	    boundaryPlayerFlag[i] = false;
	    finishDiags[i] = false;
	    numRects[i] = 0;
	    clockwise[i] = false;
	    curFiller[i] = new Vertex(size-2, size-2);
	    prevVertex[i] = new Vertex(0,0);
	    fillerCounter[i] = 0;
	    fillerStatus[i] = true;
	    fillerLength[i] = 0;
	    fillerWidth[i] = 0;
	}	
    }

    public Robot[] getInitialPositions(ArrayList indices) throws Exception {
	int max = indices.size();
	Robot[] tmp = new Robot[max];

	if(max >= 1){
	    addDiagonalPlayer(((Integer)indices.get(0)).intValue());
	    tmp[0] = robots[((Integer)indices.get(0)).intValue()];
	}

	if(max >= 2){
	    addFillerPlayer(((Integer)indices.get(1)).intValue(), size-1, size-1);
	    tmp[1] = robots[((Integer)indices.get(1)).intValue()]; 
	}

	for(int i=2; i<max; i++){
	    if(i%5 == 1){
		addFillerPlayer(((Integer)indices.get(i)).intValue(), random.nextInt(size-1), random.nextInt(size-1));
		tmp[i] = robots[((Integer)indices.get(i)).intValue()];
	    }else{
		addDiagonalPlayer(((Integer)indices.get(i)).intValue());
		tmp[i] = robots[((Integer)indices.get(i)).intValue()];
	    }
	}
		
        return tmp;
    }
	
    /***********************************************
     * HELPER METHODS
     ***********************************************/

    public void switchToChasers(int index) throws Exception{
	botPlayers[index] = _CHASER;
    }
 

    public void addRobot(int index, String type) throws Exception{
	if(type.equals(_FILLER)){
	    switchToFillerPlayer(index);
	}else if(type.equals(_BOUNDARY)){
	    switchToBoundaryPlayer(index);
	}
    }


    public void switchToFillerPlayer(int index) throws Exception{
	if(cannotMoveNorth(index) == 'N'){
	    curFiller[index].setYpos(robots[index].ypos()+1);
	}else if(cannotMoveSouth(index) == 'S'){
	    curFiller[index].setYpos(robots[index].ypos()-1);
	}else{
	    curFiller[index].setYpos(robots[index].ypos());
	}

	if(cannotMoveEast(index) == 'E'){
	    curFiller[index].setXpos(robots[index].xpos()-1);
	}else if(cannotMoveWest(index) == 'W'){
	    curFiller[index].setXpos(robots[index].xpos()+1);
	}else{
	    curFiller[index].setXpos(robots[index].xpos());
	}
	botPlayers[index] = _FILLER;
    }

    public void addFillerPlayer(int index, int x, int y) throws Exception{
	botPlayers[index] = _FILLER;
	robots[index] = new Robot(x, y);
    }
	
    public void addDiagonalPlayer(int index) throws Exception{
	int numPlayers = numPlayers(_DIAGONAL);
	//if there the first diagonal player, then its the main diagonal player
	if(numPlayers == 0){
	    robots[index] = new Robot(diagStartPoint,size-1-sqsize);
	    botPlayers[index] = _DIAGONAL;
	}else if(numPlayers%2 == 1){
	    int tmp = diagStartPoint+((int)((double)numPlayers/2.0 - 0.5)+1)*2*sqsize;
	    if(tmp <size){
		robots[index] = new Robot(tmp, size-1-sqsize);
	    }else{
		robots[index] = new Robot(random.nextInt(size-1), random.nextInt(size-1));
	    }
	    botPlayers[index] = _DIAGONAL;
	}else{
	    int tmp =  size-1-(((numPlayers/2)+1)*2*sqsize);
	    if(tmp >= 0) {
		robots[index] = new Robot(diagStartPoint, tmp);
	    }else{
		robots[index] = new Robot(random.nextInt(size-1), random.nextInt(size-1));
	    }
	    botPlayers[index] = _DIAGONAL;
	}
    }
	
    public void switchToBoundaryPlayer(int index){
	botPlayers[index] = _BOUNDARY;
	clockwiseFlag = !clockwiseFlag;
	clockwise[index] = clockwiseFlag;
    }

    public int numPlayers(String player){
	int count = 0;
	for(int i=0; i<botPlayers.length; i++){
	    if(botPlayers[i].equals(player)){
		count++;
	    }
	}

	return count;
    }
	
    public char cannotMoveWest(int index) throws Exception{
	if(robots[index].xpos()==0)
	    return 'W';
		
	return '0';
    }
    
    public char cannotMoveEast(int index) throws Exception{
	if(robots[index].xpos()>=size-1)
	    return 'E';
		
	return '0';
    }
    
    public char cannotMoveSouth(int index) throws Exception{
	if(robots[index].ypos()>=size-1)
	    return 'S';
		
	return '0';
    }
    
    public char	cannotMoveNorth(int index) throws Exception{
	if(robots[index].ypos()==0)
	    return 'N';
		
	return '0';
    }
    
    public char moveTowards(int x, int y, int index) throws Exception{
	if(x != robots[index].xpos()){
	    //move towards x....
	    if(x > robots[index].xpos()){
		//move right
		return 'E';
	    }else{
		//move left
		return 'W';
	    }
	}
		
	if(y > robots[index].ypos()){
	    //move down
	    return 'S';
	}
		
	return 'N';
		
    }

    public char moveTowards(char boundary, int index) throws Exception{

	int x = 0;
	int y = 0;
	if(boundary=='W'){
	    x = 0;
	    y = robots[index].ypos();
	}else if(boundary=='E'){
	    x = size-1;
	    y = robots[index].ypos();
	}else if(boundary=='N'){
	    x = robots[index].xpos();
	    y = 0;
	}else if(boundary=='S'){
	    x = robots[index].xpos();
	    y = size-1;
	}
		
	if(x != robots[index].xpos()){
	    //move towards x....
	    if(x > robots[index].xpos()){
		//move right
		return 'E';
	    }else{
		//move left
		return 'W';
	    }
	}
		
	if(y > robots[index].ypos()){
	    //move down
	    return 'S';
	}
		
	return 'N';
		
    }
    
    public char atBoundary(int index, char dir) throws Exception{
	if(dir == 'E'){
	    return cannotMoveEast(index);
	}else if(dir == 'W'){
	    return cannotMoveWest(index);
	}else if(dir == 'N'){
	    return cannotMoveNorth(index);
	}else if(dir == 'S'){
	    return cannotMoveSouth(index);
	}
	return '0';
    }
    
    public char atBoundary(int index) throws Exception{
	for(int i=0; i<MOVE.length; i++){
	    char tmp = atBoundary(index,MOVE[i]);
	    if(tmp != '0')
		return tmp;
	}
		
	return '0';
    }
	
    public int directionIndex(char dir, char[] moves){
	for(int i=0; i<moves.length; i++){
	    if(dir == moves[i])
		return i;
	}
		
	return -1;
    }
    
    public char makeRect(int index, int rSize, boolean clockwise) throws Exception{
	if(clockwise == false)
	    return makeAntiClockwiseRect(index, rSize);

	return makeClockwiseRect(index, rSize);
    }

    public char makeClockwiseRect(int index, int rSize) throws Exception{
	char RET;
        if(counter[index] <= rSize){
	    if(atBoundary(index, MOVE[direction[index]]) != '0'){
		counter[index] = 1;
		direction[index]--;
				
		if(direction[index]<0)
		    direction[index] = MOVE.length-1;
	    }					
	    RET = MOVE[direction[index]];
	}
	else{
	    if(direction[index] > 0){
		direction[index]--;
				
		counter[index] = 1;
	    }
	    else{
		direction[index] = MOVE.length-1;
		counter[index] = 1;
	    }
	    RET = MOVE[direction[index]];
	}
	counter[index]++;
	return RET;
    }

    public char makeAntiClockwiseRect(int index, int rSize) throws Exception{
	char RET;
        if(counter[index] <= rSize){
	    if(atBoundary(index, MOVE[direction[index]]) != '0'){
		counter[index] = 1;
		direction[index]++;
				
		if(direction[index]>MOVE.length-1)
		    direction[index] = 0;
	    }					
	    RET = MOVE[direction[index]];
	}
	else{
	    if(direction[index] < MOVE.length - 1){
		direction[index]++;
				
		counter[index] = 1;
	    }
	    else{
		direction[index] = 0;
		counter[index] = 1;
	    }
	    RET = MOVE[direction[index]];
	}
	counter[index]++;
	return RET;
    }

    /**************************************************
     * DIAGONAL PLAYER METHODS
     *************************************************/
	
    //make rectangles in diagonals
    public char diagonalPlayer(int index) throws Exception{
        char RET;
	try{
	    if(cannotMoveNorth(index) == 'N' || cannotMoveEast(index) == 'E' || cannotMoveWest(index) == 'W'){
		finishDiags[index] = true;
		return finishDiagonals(index);
	    }
			
	    if(numRects[index] == 0 && !finishDiags[index]){
		return firstRectangle(index);
	    }else if(numRects[index] > 0)
		return secondRectangle(index);
	}catch(Exception e){
		return noMovePlayer(index);
	}
	return finishDiagonals(index);
	    
    }

    public char firstRectangle(int index) throws Exception{
	char RET;
        if(counter[index] <= sqsize){
	    if(atBoundary(index, MOVE[direction[index]]) != '0'){
		counter[index] = 1;
		direction[index]++;
				
		if(direction[index]>MOVE.length-1)
		    direction[index] = 0;
	    }					
	    RET = MOVE[direction[index]];
	}
	else{
	    if(direction[index] < MOVE.length - 1){
		direction[index]++;
				
		counter[index] = 1;
	    }
	    else{
		direction[index] = 0;
		numRects[index]++;
		counter[index] = 1;
		numRects[index] = 1;
		return secondRectangle(index);
	    }
	    RET = MOVE[direction[index]];
	}
	counter[index]++;
	return RET;		
    }
    
    public char secondRectangle(int index) throws Exception{
	char RET;
	if(counter[index] <= diag_rectsize){
	    RET = DIAGMOVE2[direction[index]];
	}else{
	    if(direction[index] < DIAGMOVE2.length -1){
		direction[index]++;
		counter[index] = 1;
	    }else{
		direction[index] = 0;
		counter[index] = 1;
	    }
	    RET = DIAGMOVE2[direction[index]];
	}

	counter[index]++;
	return RET;
    }
    
    public char finishDiagonals(int index) throws Exception{
	counter[index] = 1;
	int numPlayers = numPlayers(_BOUNDARY);
	if(numPlayers < numBoundaryPlayers){
	    switchToBoundaryPlayer(index);
	}else{
	    if(numPlayers(_FILLER) < numFillerPlayers){
		switchToFillerPlayer(index);
	    }else
		return noMovePlayer(index);
	}
	return playerMoves(index);
    }
	


    /*********************************************
     * BOUNDARY PLAYER METHODS
     ********************************************/
	
    public char closestBoundary(int index) throws Exception{
	char min = MOVE[0];
	int minCounter = size;
	for(int i=0; i<MOVE.length; i++){
	    if(MOVE[i] == 'W'){
		if(minCounter > robots[index].xpos()){
		    minCounter = robots[index].xpos();
		    min = 'W';
		}
	    }else if(MOVE[i] == 'E'){
		if(minCounter > (size-1-robots[index].xpos())){
		    minCounter = size-1-robots[index].xpos();
		    min = 'E';
		}
	    }else if(MOVE[i] == 'N'){
		if(minCounter > robots[index].ypos()){
		    minCounter = robots[index].ypos();
		    min = 'N';
		}
	    }else if(MOVE[i] == 'S'){
		if(minCounter > (size-1-robots[index].ypos())){
		    minCounter = size-1-robots[index].ypos();
		    min = 'S';
		}
	    }
	}
	return min;
    }

    //goes round the boundary
    public char boundaryPlayer(int index) throws Exception{
	char tmp = atBoundary(index);
	if(tmp != '0'){
	    if(boundaryPlayerFlag[index] == false){
		boundaryPlayerFlag[index] = true;
		int i = directionIndex(tmp, MOVE);
		if(i == -1){
			return noMovePlayer(index);
		}else{
		    direction[index] = i;
		}
	    }
	    return makeRect(index, size, clockwise[index]);
	}

	boundaryPlayerFlag[index] = false;
	return moveTowards(closestBoundary(index), index);
    }
	
    /*********************************************
     * NO MOVE PLAYER METHODS
     ********************************************/
	
    //robot does not move at all
    public char noMovePlayer(int index){
	return 'Y';
    }

    /*******************************************
     * FILLER METHODS
     *******************************************/

    public Vertex findEmpty(int x, int y, int index) throws Exception{
	for(int i=y; i>0; i--){
	    for(int j=x; j>0; j--){
		if(!filled[j][i] && !filled[j][i-1]){
		    if((y-1==0 || y+1==filled.length-1) && (filled[j+1][i] && filled[j-1][i])){
			continue;
		    }else{
			if(filled[j][i+1]){
			    continue;
			}else{
			    if(filled[j+1][i] || filled[j-1][i]){
				continue;
			    }else{
				if(filled[j-1][i-1] || filled[j+1][i+1] || filled[j-1][i-1] || filled[j+1][i+1]){
				    continue;
				}else{
				    if(prevVertexContains(new Vertex(j,i))){
					continue;
				    }else{
					return new Vertex(j,i);
				    }
				}
			    }
			}
		    }
		}
	    }
	}
		
	return null;
    }				

	

    public Vertex findEmpty(int index) throws Exception{
	return findEmpty(filled.length-2, filled.length-2, index);

    }

    public boolean prevVertexContains(Vertex v) throws Exception{
	for(int i=0; i<prevVertex.length; i++){
	    if(prevVertexContains(i,v))
		return true;
	}

	return false;
    }

    public boolean prevVertexContains(int index, Vertex v) throws Exception{
	if(prevVertex[index].xpos() == v.xpos() && prevVertex[index].ypos() == v.ypos()){
	    return true;
	}
	return false;
    }

    public char fillerPlayer(int index) throws Exception{
	if(fillerStatus[index]){
	    Vertex v = findEmpty(curFiller[index].xpos(), curFiller[index].ypos(), index);
	    if(v == null){
		//done with filling
		v = findEmpty(index);
		if(v == null){
		    switchToBoundaryPlayer(index);
		    return playerMoves(index);
		    //return noMovePlayer(index);
		}
	    }
	    
	    int x = v.xpos()+1;
	    int y = v.ypos()+1;
	    
	    if(robots[index].xpos() == x && robots[index].ypos() == y){
		fillerStatus[index] = false;	
		counter[index] = 1;
		direction[index] = 0;
		prevVertex[index] = v;
			
		if(prevVertexContains(index, curFiller[index])){
		    fillerCounter[index]++;
		}else{
		    fillerCounter[index] = 0;
		}
	    }else{
		return moveTowards(x,y,index);
	    }
	}
	
	char RET;
	if(counter[index] <= fillerThresh){
	    counter[index]++;
	    int xpos = robots[index].xpos();
	    int ypos = robots[index].ypos();
	    if(MOVE3[direction[index]] == 'W'){
		if(cannotMoveWest(index) == 'W' || (xpos-1>=0 && ypos-1>=0 && (filled[xpos-1][ypos-1]||filled[xpos-1][ypos]))){
		    counter[index] = 1;
		    direction[index]++;
		}else{
		    fillerLength[index]++;
		}
	    }else if(MOVE3[direction[index]] == 'N'){
		if((cannotMoveNorth(index)=='N' || xpos+1<size && ypos-1>=0 && (filled[xpos+1][ypos-1]||filled[xpos][ypos-1]))){
		    counter[index] = 1;
		    direction[index]++;
		}else{
		    if(xpos+fillerLength[index]-2 < size && ypos-1>=0 && filled[xpos+fillerLength[index]-2][ypos-1]){
			counter[index]=1;
			direction[index]++;
		    }else
			fillerWidth[index]++;
		}			   
	    }else if(MOVE3[direction[index]] == 'E'){
		if(cannotMoveEast(index)=='E' || (xpos+1<size && ypos+1<size && filled[xpos+1][ypos+1]) || counter[index]>fillerLength[index] || filled[xpos+1][ypos]){
		    counter[index] = 1;
		    direction[index]++;
		}			   
	    }else if(MOVE3[direction[index]] == 'S'){
		if(cannotMoveSouth(index)=='S'||(xpos-1>=0 && ypos+1<size && filled[xpos-1][ypos+1]) || counter[index]>fillerWidth[index] || filled[xpos][ypos+1]){
		    counter[index] = 1;
		    direction[index] = 0;
		    fillerStatus[index] = true;
		    fillerLength[index] = 0;
		    fillerWidth[index] = 0;
		    curFiller[index].setXpos(prevVertex[index].xpos());
		    curFiller[index].setYpos(prevVertex[index].ypos());
		}			   
	    }
	}else{
	    counter[index] = 1;

	    if(direction[index] >= MOVE3.length-1){
		direction[index] = 0;
		fillerStatus[index] = true;
		fillerLength[index] = 0;
		fillerWidth[index] = 0;
	    }else
		direction[index]++;
	}
	RET = MOVE3[direction[index]];
	
	return RET;		
    }

    /********************************************
     * MAIN MOVE METHOD
     *******************************************/
	
    public char playerMoves(int index) {
	try{
	    if(botPlayers[index].equals(_DIAGONAL))
		return diagonalPlayer(index);
	    if(botPlayers[index].equals(_BOUNDARY))
		return boundaryPlayer(index);
	    if(botPlayers[index].equals(_FILLER))
		return fillerPlayer(index);
	}catch(Exception e){
		return noMovePlayer(index);
	}
	return noMovePlayer(index);
    }

    public ArrayList doStrategy() {
	try{
	    filled = _rect.filled();
	    colors = _rect.colors();
	    robots = (_rect.allRobots())[playerIndex];
	}catch(Exception e){
	    return null;
	}
	int count = numPlayers(_DIAGONAL) + numPlayers(_BOUNDARY) + numPlayers(_FILLER);
	ArrayList list = new ArrayList(count);
	for(int i=0; i<_MAX; i++){
	    if(botPlayers[i].equals(_DIAGONAL) || botPlayers[i].equals(_BOUNDARY) || botPlayers[i].equals(_FILLER)){
		try{
		    list.add(new Character(playerMoves(i)));
		}catch(Exception e){
		    list.add(new Character('Y'));
		}
	    }
	}

	return list;
    }
	
}






