//***********************************************************
//*
//* File:           LadderPlayer.java
//* Author:         Jia Zeng
//* Contact:        
//* Update:         10.16.2002
//*
//* Description:    
//*
//***********************************************************

package Rectangles;

import ui.*;
import java.util.*;
import java.io.*;
import java.awt.Color;

public final class OldLadderPlayer implements IFCPlayer {

    Rectangles _rect;
    static Random _random;
    static final String _CNAME = "Ladder Player";
    static final Color  _CCOLOR = new Color(1.0f, 0.67f, 0.67f);
    static char[] _CDIRECTIONS = new char[4];
    int size;		// board size
    char[] rotdirect;	// the robots' last time moving direction
    int[] stepped;	//  how far the robots have stepped on a ladder
    int a;		//a is the length of the square going to build
    int[][] colors;
    int[] robotTurned;
    Robot[][] allRobotPositions;
    int myIndex;
    ArrayList path = new ArrayList();
    ArrayList pathPatch = new ArrayList();
    boolean calculated = false;
    boolean[] finished;
    double[] targetDistance;
    vertex[] targetVertex;
    int _MAX;
    int[] freeRobot = new int[1];
    int numFree = 0;
    boolean alternate = false;

    public Robot[] register(Rectangles __rectangles) throws Exception {
        Robot[] RET;
        int lastpos;	//record the last init position
        int playernum;
        

	_CDIRECTIONS[0] = 'E';
	_CDIRECTIONS[1] = 'S';
	_CDIRECTIONS[2] = 'W';
	_CDIRECTIONS[3] = 'N';   	
	
        _rect = __rectangles;
	
	myIndex = _rect.indexOf(this);
	
        if (_random  == null) {
            _random = new Random();
        }

        _MAX = _rect.numRobots();
	numFree = _MAX / 5;
	if(numFree > 0){
	    freeRobot = new int[numFree];
	}
	int newMax = _MAX;
	if(numFree != 0){
	    for(int k = 0; k < numFree; k++){
		newMax--;
		freeRobot[k] = newMax;
	    }
	}

        playernum = _rect.numPlayers();
	//System.out.println("num of players : " + playernum);
        size = _rect.size();
        //use it to be not greedy
        a =  5 *((size/(newMax))/playernum); 
	//use it to be greedy
	//a = 2* (size/_MAX);       
        if (a > size / (newMax) * 2)
	    a = size / (newMax) * 2;
        //System.out.println("a = "+a);
        RET = new Robot[_MAX];
        rotdirect = new char[_MAX];
        stepped = new int[_MAX]; 
        robotTurned = new int[_MAX];
	finished = new boolean[_MAX];
	targetDistance = new double[_MAX];
	targetVertex = new vertex[_MAX];
	
	for(int index = 0; index < _MAX; index++){
	    finished[index] = false;
	    targetDistance[index] = 0;
	    targetVertex[index] = null;
	}
	
        RET[0] = new Robot(0,0);
        rotdirect[0] = 'E';	// East
        lastpos = 0;
        //System.out.println("Place robot[0] at "+RET[0]+" go "+rotdirect[0]); 
	
        if (_MAX > 1)
	    {        	
		RET[1] = new Robot(0,0);
		rotdirect[1] = 'S';	// South
		//System.out.println("Place robot[1] at "+RET[1]+" go "+rotdirect[1]); 
	    }
	for (int i=2; i < newMax; i++) {
	    if ((i%2)==1)
        	{ 
		    RET[i] = new Robot(lastpos,0);
		    rotdirect[i] = 'E';	// East
		    //System.out.println("Place robot["+i+"] at "+RET[i]+" go "+rotdirect[i]);        		
        	}
	    else
        	{
		    lastpos = lastpos+a-1;
		    RET[i] = new Robot(0,lastpos);
		    rotdirect[i] = 'S';	// South
		    //System.out.println("Place robot["+i+"] at "+RET[i]+" go "+rotdirect[i]);        		        	
        	} 
	    stepped[i] = 0; 
        }
	for(int i = 0; i < freeRobot.length; i++){
	    RET[freeRobot[i]] = new Robot(0, 0);
	}
        return RET;
    }
    
    char findMove(int rIndex, boolean stop) throws Exception{
	int x = allRobotPositions[myIndex][rIndex].xpos();
	int y = allRobotPositions[myIndex][rIndex].ypos();
	int xPos = allRobotPositions[myIndex][rIndex].xpos();
	int yPos = allRobotPositions[myIndex][rIndex].ypos();
	int offX = 0, offY = 0;
	double minDistance = 10000;
	int minIndex = -1;
	double d = 0;
	boolean add = true;
	switch (rotdirect[rIndex]){
	case 'E':
	    offX++;
	    break;
	case 'S': 
	    offY++;
	    break;
	case 'W': 
	    offX--;
	    break;
	case 'N': 
	    offY--;
	    break;
	default: ;
	}
	x += offX;
	y += offY;
	//System.out.println("CHECKING COLOR");
	if(stop == false && x < size && y < size && x > 0  && y > 0 && finished[rIndex] == false && colors[x][y] != _CFILLED && colors[x][y] != myIndex){
	    //System.out.println("COLORS : " + x + ", " + y + rotdirect[rIndex]);
	    return rotdirect[rIndex];
	}	
	else{
	    //System.out.println("ELSE");
	    finished[rIndex] = true;
	    if(calculated == false){
		//System.out.println(path.size());
		for(int j = 0; j < path.size(); j++){
		    add = true;
		    vertex temp = (vertex)path.get(j);
		    if(colors[temp.x][temp.y] != _CFILLED && colors[temp.x][temp.y] != myIndex){
			/**********
			       middle
			**********/
			if(temp.x > 0 && temp.x < size - 1 && temp.y > 0 && temp.y < size - 1){
			    if(colors[temp.x - 1][temp.y] == _CFILLED && colors[temp.x + 1][temp.y] == _CFILLED)
				add = false;
			    if(colors[temp.x][temp.y + 1] == _CFILLED && colors[temp.x][temp.y - 1] == _CFILLED)
				add = false;
			    if(colors[temp.x - 1][temp.y - 1] == _CFILLED
			       && colors[temp.x + 1][temp.y - 1] == _CFILLED
			       && colors[temp.x - 1][temp.y + 1] == _CFILLED
			       && colors[temp.x + 1][temp.y + 1] == _CFILLED)
				add = false;
			}
			/**********
				   left edge middle
			*************/
			if(temp.x == 0 && temp.y > 0 && temp.y < size - 1){
			    if(colors[temp.x + 1][temp.y] == _CFILLED)
				add = false;
 
			}
			/********
				 right edge
			*****/
			if(temp.x == size - 1 && temp.y > 0 && temp.y < size - 1){
			    if(colors[temp.x - 1][temp.y] == _CFILLED)
				add = false;
			}
			/*********
				  top edge
			*********/
			if(temp.y == 0 && temp.x > 0 && temp.x < size - 1){
			    if(colors[temp.x][temp.y + 1] == _CFILLED)
				add = false;
			}
			/**********
				   bottom edge
			************/
			if(temp.y == size - 1 && temp.x > 0 && temp.x < size - 1){
			    if(colors[temp.x][temp.y - 1] == _CFILLED)
				add = false;
			}
			/*********
				  Upper Left Corner
			*************/
			if(temp.y == 0 && temp.x == 0){
			    if(colors[temp.x + 1][temp.y + 1] == _CFILLED)
				add = false;
			}
			/******
			       Uppder Right Corner
			*******/
			if(temp.y == 0 && temp.x == size - 1){
			    if(colors[temp.x - 1][temp.y - 1] == _CFILLED)
				add = false;
			}
			/******
			       Lower Left Corner
			*********/
			if(temp.y == size - 1 && temp.x == 0){
			    if(colors[temp.x + 1][temp.y - 1] == _CFILLED)
				add = false;
			}
			/******
			       Lower Right Corner
			****/
			if(temp.y == size - 1 && temp.x == size - 1){
			    if(colors[temp.x - 1][temp.y - 1] == _CFILLED)
				add = false;
			}
											      
			
			if(add == true){
			    pathPatch.add(temp);
			}
		    }
		}
		calculated = true;
	    }
	    for(int j = 0; j < pathPatch.size(); j++){
		vertex temp = (vertex)pathPatch.get(j);
		d = distance(temp.x, temp.y, x, y);
		//System.out.println("DISTANCE : " + d);
		if(d == 0){
		    pathPatch.remove(j);
		}
		if(d < minDistance && d != 0){
		    minDistance = d;
		    
		    minIndex = j;
		}	
	    }
	    if(minIndex != -1){
		vertex temp = (vertex)pathPatch.get(minIndex);
		targetDistance[rIndex] = minDistance;
		targetVertex[rIndex] = new vertex(temp.x, temp.y);
		pathPatch.remove(minIndex);
		return getDirection(temp.x, temp.y, xPos, yPos);
	    }
	}
	if(alternate){
	    alternate = false;
	    return 'S';
	}
	else{
	    alternate = true;
	    return 'E';
	}
    }
    char getDirection(int destX, int destY, int fromX, int fromY) throws Exception{
	//System.out.println("DEST : " + destX + ", " + destY + " FROM : " + fromX + ", " + fromY);
	if(destY > fromY){
	    return 'S';
	}
	else if(destY < fromY){
	    return 'N';
	}
	else if(destX < fromX){
	    return 'W';
	}
	else if(destX > fromX){
	    return 'E';
	}
	else
	    return 'Y';
    }
    double distance(int x1, int y1, int x2, int y2) throws Exception{
	x1++;
	y1++;
	return(Math.sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2)));
    }


    double density(int x, int y) throws Exception{
	double d = 0;
	for(int x1 = x; x1 < size; x1++){
	    for(int y1 = y; y1 < size; y1++){
		if(colors[x][y] == _CFILLED){
		    d++;
		}
	    }
	}
	return d;
	
    }


    public char[] move() throws Exception {
        Robot[][] allrs;
        Robot[] myrobots;
	colors = _rect.colors();
	pathPatch.clear();
	allRobotPositions = _rect.allRobots();
	calculated = false;
	allrs = _rect.allRobots();
	myrobots = allrs[_rect.indexOf(this)];
	boolean found = false;
	boolean breakApart = false;
        
	if(breakApart == true){
	    for(int i = 0; i < _MAX; i++){
		findMove(i, true);
	    }
	    return rotdirect;
	}
	if(_MAX > 2){
	    int x1 = allRobotPositions[myIndex][0].xpos();
	    int y1 = allRobotPositions[myIndex][0].ypos();
	    int x2 = allRobotPositions[myIndex][1].xpos();
	    int y2 = allRobotPositions[myIndex][1].ypos();
	    if(x1 == x2 && y1 == y2 && x1 >= size / 2.5 && y1 >= size / 2.5){
		double d = density(x1, y1);
		if((d / ((size - x1) * (size - y1))) > .75){
		    for(int i = 0; i < _MAX; i++){
			rotdirect[i] = findMove(i, true);
		    }
		    breakApart = true;
		    return rotdirect;
		}
	    }
	}
	for (int i=0; i < _MAX; i++) {
	    found = false;
	    if(numFree > 0){
		for(int k = 0; k < freeRobot.length; k++){
		    if(i == freeRobot[k]){
			found = true;
			rotdirect[i] = findMove(i, false);
		    }
		}
	    }
	    if(found == false){
		int rX = allRobotPositions[myIndex][i].xpos();
		int rY = allRobotPositions[myIndex][i].ypos();
		if(path.size() > 200){
		    path.remove(path.size() - 1);
		}
		path.add(new vertex(rX, rY));
		if (((myrobots[i].xpos() >= (size-1)) && (rotdirect[i] == 'E'))||((myrobots[i].xpos() <= 0) && (rotdirect[i] == 'W'))){
		    stepped[i] = 0;
		    robotTurned[i]++;
		    if (myrobots[i].ypos() >= (a/2-1))
			rotdirect[i] = 'N';
		    else
			rotdirect[i] = 'S';
		}		
		else if (((myrobots[i].ypos()>=(size-1)) && (rotdirect[i] == 'S'))||((myrobots[i].ypos()<=0) && (rotdirect[i] == 'N'))){
		    stepped[i] = 0;
		    robotTurned[i]++;
		    if (myrobots[i].xpos()>=(a/2-1))
			rotdirect[i] = 'W';
		    else
			rotdirect[i] = 'E';
		}		
		else if (stepped[i] == a - 1)	//end of a labber, change direction
		    {
			stepped[i] = 0;
			switch (rotdirect[i]){
			case 'E': rotdirect[i] = 'S';
			    break;
			case 'S': rotdirect[i] = 'E';
			    break;
			case 'W': rotdirect[i] = 'N';
			    break;
			case 'N': rotdirect[i] = 'W';
			    break;
			default: ;
			}
		    }
		if(robotTurned[i] == 2){
		    rotdirect[i] = findMove(i, false);
		}
		stepped[i]++;
	    }
	}                    		
	return rotdirect;
    }
    
    public String name() throws Exception {
        return _CNAME;
    }

    public Color color() throws Exception {
        return _CCOLOR;
    }

    public boolean interactive() throws Exception {
        return false;
    }
    
    class vertex{
	public int x;
	public int y;
	public vertex(int x1, int y1){
	    x = x1;
	    y = y1;
	}
    }
    
}

